/*************************************************************/
/*  mmm   - calculates max, min and mean value of image      */
/*                                                           */
/* Latest update: MAR 92 SS                                  */
/*************************************************************/

/****************************************************************************/
/*                                                                           */
/* Notice:                                                                   */
/* =======                                                                   */
/*                                                                           */
/* I make no warranties that this program is (1) free of error, (2) con-     */
/* sistent with any standard merchantability, or (3) meeting the require-    */
/* ments of a particular application.  This software shall not, partly or    */
/* as a whole, participate in a process, whose outcome can result in injury  */
/* to a person or loss of property. It is solely designed for analytical     */
/* work.  Permission to use, copy, and distribute is hereby granted without  */
/* fee, providing that the header above including this notice appears in     */
/* all copies.                                                               */
/*                                                                           */
/*                                                         Stefan Spaennare  */
/*                                                                           */
/*****************************************************************************/


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "image.h"

int main(argc,argv)
int argc;
char *argv[];
{
   struct image_head header;       
   short row,col;
   short **image;

   int min, max, temp;
   double total, maxr, minr;


   if (argc<2) {
      printf("Usage: %s image\n",argv[0]);
      exit(0);
   } /* if */

   ReadHeader(argv[1],&header);

   image = (short **)calloc(header.hgh,sizeof(short*));

   ReadImage(argv[1],image);


   max = -32768;
   min =  32767;
   total = 0.0;

   for (row=0; row<header.hgh; row++) {
      for (col=0; col<header.wid; col++) {

         temp = image[row][col];
         total = total+temp;

	 if (temp > max) {
	    max=temp;
	 } /* if */
	 if (temp < min) {
	    min= temp;
	 } /* if */

      } /* for col */
    } /* for row */

   maxr = (double)(max)/32767.0;
   minr = (double)(min)/32768.0;

   total = total /(double)(header.wid*header.hgh);

   printf("%3d %3d %12.7lf %12.7lf %12.7lf\n",max,min,maxr,minr,total);
    

} /* End */
